<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdditionalDetailType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfAdditionalDetailType extends AbstractStructArrayBase
{
    /**
     * The AdditionalDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgAdditionalDetailType[]
     */
    public $AdditionalDetail;
    /**
     * Constructor method for ArrayOfAdditionalDetailType
     * @uses DgArrayOfAdditionalDetailType::setAdditionalDetail()
     * @param \dgsoft\StructType\DgAdditionalDetailType[] $additionalDetail
     */
    public function __construct(array $additionalDetail = array())
    {
        $this
            ->setAdditionalDetail($additionalDetail);
    }
    /**
     * Get AdditionalDetail value
     * @return \dgsoft\StructType\DgAdditionalDetailType[]|null
     */
    public function getAdditionalDetail()
    {
        return $this->AdditionalDetail;
    }
    /**
     * Set AdditionalDetail value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgAdditionalDetailType[] $additionalDetail
     * @return \dgsoft\ArrayType\DgArrayOfAdditionalDetailType
     */
    public function setAdditionalDetail(array $additionalDetail = array())
    {
        foreach ($additionalDetail as $arrayOfAdditionalDetailTypeAdditionalDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdditionalDetailTypeAdditionalDetailItem instanceof \dgsoft\StructType\DgAdditionalDetailType) {
                throw new \InvalidArgumentException(sprintf('The AdditionalDetail property can only contain items of \dgsoft\StructType\DgAdditionalDetailType, "%s" given', is_object($arrayOfAdditionalDetailTypeAdditionalDetailItem) ? get_class($arrayOfAdditionalDetailTypeAdditionalDetailItem) : gettype($arrayOfAdditionalDetailTypeAdditionalDetailItem)), __LINE__);
            }
        }
        $this->AdditionalDetail = $additionalDetail;
        return $this;
    }
    /**
     * Add item to AdditionalDetail value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgAdditionalDetailType $item
     * @return \dgsoft\ArrayType\DgArrayOfAdditionalDetailType
     */
    public function addToAdditionalDetail(\dgsoft\StructType\DgAdditionalDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgAdditionalDetailType) {
            throw new \InvalidArgumentException(sprintf('The AdditionalDetail property can only contain items of \dgsoft\StructType\DgAdditionalDetailType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AdditionalDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgAdditionalDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgAdditionalDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgAdditionalDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgAdditionalDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgAdditionalDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdditionalDetail
     */
    public function getAttributeName()
    {
        return 'AdditionalDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfAdditionalDetailType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
